﻿using Infragistics.Controls.Grids;
using Infragistics.Olap.Data;
using Infragistics.Olap.FlatData;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace PivotGridPreventEditDemo
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            string colString = "[Date].[Date]";
            string rowString = "[City].[City]";
            string filterString = "[Seller].[Seller]";
            string measureString = "AmountOfSale";
            string cubeString = "[Sale]";

            SalesDataSample sample = new SalesDataSample();

            FlatDataSource fds = new FlatDataSource() { ItemsSource = sample };


            fds.DimensionsGenerationMode = DimensionsGenerationMode.Property;
            fds.ConnectionSettings = new FlatDataConnectionSettings() { ItemsSource = sample };

            fds.Cube = Infragistics.Olap.DataSourceBase.GenerateInitialCube(cubeString);
            fds.Columns = Infragistics.Olap.DataSourceBase.GenerateInitialItems(colString);
            fds.Rows = Infragistics.Olap.DataSourceBase.GenerateInitialItems(rowString);
            fds.Measures = Infragistics.Olap.DataSourceBase.GenerateInitialItems(measureString);
            fds.Filters = Infragistics.Olap.DataSourceBase.GenerateInitialItems(filterString);

            pivot.DataSource = fds;

            selector.DataSource = fds;
        }

        private void pivot_Loaded(object sender, RoutedEventArgs e)
        {
            FlatDataSource fds = pivot.DataSource as FlatDataSource;

            EditSettings settings = new EditSettings();
            settings.AllowCellEdit = true;                      

            foreach (IMeasure x in fds.Cube.Measures)
            {
                settings.EditableMeasures.Add(x);
            }

            pivot.EditSettings = settings;
        }

        private void PivotCellControl_PreviewMouseDown(object sender, MouseButtonEventArgs e)
        {
            PivotCellControl control = sender as PivotCellControl;
            PivotCell cell = control.Cell as PivotCell;

            if(cell.DataColumn.IsTotal || cell.DataRow.IsTotal)
            {
                e.Handled = true;
            }
        }
    }
}
